{-# LANGUAGE TypeFamilies #-}
module Data.ImplicitMultiMap (ImplicitMultiMap, DeriveKey(..), empty) where
import Data.Kind (Type)
import Data.Map (Map)
import Data.Set (Set)
import qualified Data.Map as Map

class DeriveKey a where
  type KeyOf a :: Type
  deriveKey :: a -> KeyOf a

newtype ImplicitMultiMap a = ImplicitMultiMap (Map (KeyOf a) (Set a))

empty :: ImplicitMultiMap a
empty = ImplicitMultiMap Map.empty
